{"openapi":"3.0.3","info":{"description":"Sinum Central Device Local API documentation","version":"1.0.0","title":"[Local] Sinum API","contact":{"email":"wojciech.marmurowicz@techsterowniki.pl"}},"servers":[{"description":"Sinum Local API","url":"http://{hostname_or_ip}/api/v1","variables":{"hostname_or_ip":{"default":"sinum.local"}}}],"security":[{"JWT":[]}],"tags":[{"name":"auth","description":"Authentication endpoints"},{"name":"users","description":"Users endpoints"},{"name":"dashboards","description":"Dashboard management endpoints"},{"name":"user-dashboard-ids","description":"Management of user-dashboard associations"},{"name":"web-socket","description":"WebSocket endpoint"},{"name":"translations","description":"Translations endpoint"},{"name":"regulations","description":"Regulations endpoints"},{"name":"feature-flags","description":"Feature flags endpoint"},{"name":"token-api","description":"Menage token api"},{"name":"default-dashboards","description":"Default dashboards management - dashboards assigned to new users"},{"name":"devices","description":"Devices general endpoints"},{"name":"devices/wtp","description":"WTP Devices (Wireless) endpoints"},{"name":"devices/tech","description":"TECH Devices (Wired) endpoints"},{"name":"devices/virtual","description":"Virtual Devices endpoints"},{"name":"devices/sbus","description":"SBus Devices endpoints"},{"name":"devices/slink","description":"SLink Devices endpoints"},{"name":"devices/system-module","description":"System Module Devices endpoints"},{"name":"devices/lora","description":"Lora Devices endpoints"},{"name":"devices/alarm-system","description":"Alarm system Devices endpoints"},{"name":"devices/modbus","description":"Modbus Devices endpoints"},{"name":"devices/custom-device-module","description":"Custom device modules endpoints"},{"name":"devices/video","description":"Video devices endpoints"},{"name":"marketplace","description":"Marketplace endpoints"},{"name":"device-network","description":"Device network diagnostic endpoints"},{"name":"parent-devices","description":"Parent Devices endpoints"},{"name":"parent-devices/wtp","description":"WTP Parent Devices endpoints"},{"name":"parent-devices/sbus","description":"SBus Parent Devices endpoints"},{"name":"parent-devices/slink","description":"SLink Parent Devices endpoints"},{"name":"parent-devices/tech","description":"TECH Parent Devices endpoints"},{"name":"parent-devices/lora","description":"LoRA Parent Devices endpoints"},{"name":"parent-devices/system-module","description":"SystemModule Parent Devices endpoints"},{"name":"parent-devices/modbus","description":"Modbus Parent Devices endpoints"},{"name":"parent-devices/alarm-system","description":"AlarmSystem Parent Devices endpoints"},{"name":"parent-devices/video","description":"Video Parent Devices endpoints"},{"name":"scenes","description":"Scenes endpoints"},{"name":"automations","description":"Automations endpoints"},{"name":"directories/automations","description":"Automations directories endpoints"},{"name":"directories/scenes","description":"Scenes directories endpoints"},{"name":"schedules","description":"Schedules endpoints"},{"name":"rooms","description":"Rooms endpoints"},{"name":"weather","description":"Weather endpoints"},{"name":"energy-center/associations","description":"EnergyCenter Associations endpoints"},{"name":"energy-center/flow-monitor","description":"EnergyCenter Flow Monitor endpoints"},{"name":"energy-center/prices","description":"EnergyCenter Prices Endpoint"},{"name":"energy-center/energy-storage","description":"EnergyCenter Energy Storage endpoints"},{"name":"energy-center/energy-consumption","description":"EnergyCenter Energy Consumption endpoints"},{"name":"energy-center/energy-production","description":"EnergyCenter Energy Production endpoints"},{"name":"energy-center","description":"EnergyCenter General endpoints"},{"name":"lua","description":"General lua endpoints"},{"name":"lua/variables","description":"Lua variables endpoints"},{"name":"lua/timers","description":"Lua timers endpoints"},{"name":"lua/examples","description":"Lua code examples endpoints"},{"name":"lua/modbus-clients","description":"Lua Modbus Clients endpoints"},{"name":"lua/http-clients","description":"Lua HTTP Clients endpoints"},{"name":"lua/mqtt-clients","description":"Lua MQTT Clients endpoints"},{"name":"lua/ws-clients","description":"Lua Websocket Clients endpoints"},{"name":"lua/http-server","description":"Lua HTTP Server forwarding endpoints"},{"name":"lua/libraries","description":"Lua Libraries endpoints"},{"name":"influx","description":"InfluxDB statistics endpoints"},{"name":"influx/notifications","description":"InfluxDB notification endpoints"},{"name":"influx/access-history","description":"InfluxDB access history endpoints"},{"name":"influx/query-template","description":"InfluxDB Templated statistics endpoints"},{"name":"influx/login-history","description":"InfluxDb login history endpoints"},{"name":"settings/localization","description":"Localization settings endpoints"},{"name":"settings/locale","description":"Locale / Regional settings endpoints"},{"name":"settings/main/logs","description":"Log settings endpoints"},{"name":"settings/weather","description":"Weather settings endpoints"},{"name":"settings/modbus","description":"Modbus settings endpoints"},{"name":"settings/floors","description":"Floors settings endpoints"},{"name":"settings/network","description":"Settings/Network endpoints"},{"name":"settings/hostname","description":"Settings/Hostname endpoints"},{"name":"settings/time","description":"Settings/time endpoints"},{"name":"settings/update","description":"Settings/update endpoints"},{"name":"settings/backup","description":"Settings backup endpoints"},{"name":"settings/cyclic-backup","description":"Settings cyclic backup endpoints"},{"name":"settings/leds","description":"Leds settings endpoints"},{"name":"settings/influx-devices","description":"Settings/Influx-Devices endpoints"},{"name":"influx/backup","description":"Influx backup endpoints"},{"name":"settings/register-url","description":"Cloud register url"},{"name":"settings/pm/logs","description":"Log settings"},{"name":"system","description":"System management endpoints"},{"name":"logs","description":"Log globals"},{"name":"info","description":"Info"},{"name":"identify","description":"Identification"}],"paths":{"/ws":{"get":{"tags":["web-socket"],"summary":"Opens WebSocket","responses":{"101":{"description":"Success"}}}},"/ws-cloud":{"get":{"tags":["web-socket"],"summary":"Opens WebSocket - uid info","responses":{"101":{"description":"Success"}}}},"/login":{"post":{"tags":["auth"],"summary":"Authenticates the user","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Credentials"}}}},"security":[],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"session":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"refresh_token":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"user":{"$ref":"#/components/schemas/User"}}}}}}}},"401":{"description":"Incorrect username or password","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"object","properties":{"message":{"type":"object","properties":{"text":{"type":"string","enum":["Unfortunately, the username or password is incorrect."]},"id":{"type":"number","enum":[1135]}}}}}}}}}}}}},"/logout":{"post":{"tags":["auth"],"summary":"Removes the user's session","responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"authenticated":{"type":"boolean","enum":[false]}}}}}}}}}}},"/refresh":{"post":{"tags":["auth"],"summary":"refresh token","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RefreshToken"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"session":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"refresh_token":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"}}}}}}}}}}},"/cloud-login":{"post":{"tags":["auth"],"summary":"Cloud token authorization","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CredentialsCloud"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"session":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"refresh_token":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"user":{"$ref":"#/components/schemas/User"}}}}}}}},"400":{"description":"wrong cloud token","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"object","properties":{"message":{"type":"object","properties":{"text":{"type":"string","enum":["Unfortunately, the username or password is incorrect."]},"id":{"type":"number","enum":[1135]}}}}}}}}}}}}},"/users":{"get":{"tags":["users"],"summary":"Gets all users","description":"This can be done only by the admin","responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/User"}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"post":{"tags":["users"],"summary":"Creates user","description":"This can be done only by the admin","responses":{"200":{"description":"User account has been created","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"session":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"user":{"$ref":"#/components/schemas/User"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NewUser"}}}}}},"/users/{id}":{"patch":{"tags":["users"],"summary":"Updates the user","description":"At least one parameter in request body required","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NewUser"}}}},"responses":{"204":{"description":"User account has been updated"},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"delete":{"tags":["users"],"summary":"Deletes the user","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"responses":{"204":{"description":"User account has been deleted"},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"get":{"tags":["users"],"summary":"get user info","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"session":{"type":"string","example":"MTYzMHxuWmNmV2dGb[...]"},"user":{"$ref":"#/components/schemas/User"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users-count":{"get":{"tags":["users"],"summary":"Gets the number of users","responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"count":{"type":"number","example":1}}}}}}}},"503":{"description":"Service Unavailable","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users-count/online":{"get":{"tags":["users"],"summary":"Gets the number of users is online","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InfluxOnlineUserRunResult"}}}},"503":{"description":"Service Unavailable","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/password":{"patch":{"tags":["users"],"summary":"Updates the user password","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NewPassword"}}}},"responses":{"204":{"description":"User account has been updated"},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/dashboards":{"get":{"tags":["dashboards"],"summary":"Get all dashboards","parameters":[{"in":"query","name":"type","description":"Filter by dashboard type","schema":{"type":"string","enum":["user","default","room"]}},{"in":"query","name":"owner_id","description":"Filter by owner ID","schema":{"type":"integer"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/Dashboard"}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"post":{"tags":["dashboards"],"summary":"Create a new dashboard","description":"Creates a new dashboard. The `type` field is required.\n","requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["name","widgets","structure","type"],"properties":{"name":{"type":"string","example":"My Dashboard"},"widgets":{"type":"array","items":{"$ref":"#/components/schemas/DashboardWidget"}},"structure":{"type":"array","items":{"$ref":"#/components/schemas/WidgetStructure"}},"type":{"type":"string","description":"Dashboard type (required)","enum":["user","default","room"]},"owner_id":{"type":"integer","description":"Owner user ID (defaults to current user)"}}}}}},"responses":{"200":{"description":"Dashboard created","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error or invalid type","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - user cannot create dashboard for specified owner","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/dashboards/{id}":{"get":{"tags":["dashboards"],"summary":"Get dashboard by ID","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"patch":{"tags":["dashboards"],"summary":"Update dashboard","description":"Updates an existing dashboard.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Dashboard"}}}},"responses":{"200":{"description":"Dashboard updated","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"delete":{"tags":["dashboards"],"summary":"Delete dashboard","description":"Deletes a dashboard by ID. This operation is idempotent - deleting a non-existent dashboard returns 204 for admin users.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"Dashboard deleted successfully (or did not exist for admin users)"},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/dashboards/{id}/name":{"post":{"tags":["dashboards"],"summary":"Update dashboard name","description":"Updates only the name of a dashboard.\n\nAuthorization rules are the same as for updating the full dashboard.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["name"],"properties":{"name":{"type":"string","example":"My Dashboard"}}}}}},"responses":{"200":{"description":"Name updated","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/dashboards/{id}/widgets":{"post":{"tags":["dashboards"],"summary":"Add widget to dashboard","description":"Adds a new widget and its structure to a dashboard.\n\nAuthorization rules are the same as for updating the dashboard.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["widget","structure"],"properties":{"widget":{"$ref":"#/components/schemas/DashboardWidget"},"structure":{"$ref":"#/components/schemas/WidgetStructure"}}}}}},"responses":{"200":{"description":"Widget added","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/dashboards/{id}/widgets/{widget_id}":{"patch":{"tags":["dashboards"],"summary":"Update widget in dashboard","description":"Updates an existing widget in a dashboard.\n\nAuthorization rules are the same as for updating the dashboard.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}},{"in":"path","name":"widget_id","description":"Widget ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DashboardWidget"}}}},"responses":{"200":{"description":"Widget updated","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard or widget not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"delete":{"tags":["dashboards"],"summary":"Delete widget from dashboard","description":"Removes a widget and its structure from a dashboard.\n","parameters":[{"in":"path","name":"id","description":"Dashboard ID","required":true,"schema":{"type":"integer"}},{"in":"path","name":"widget_id","description":"Widget ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Widget deleted","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Dashboard"}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard or widget not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/dashboard-ids":{"get":{"tags":["user-dashboard-ids"],"summary":"Get user's dashboard IDs","description":"Returns the list of dashboard IDs assigned to a user.","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"type":"integer"},"example":[1,2,3]}}}}}},"400":{"description":"Bad Request - invalid user ID","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"put":{"tags":["user-dashboard-ids"],"summary":"Reorder user's dashboard IDs","description":"Reorders the list of dashboard IDs for a user. This endpoint is used only for changing\n","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"content":{"application/json":{"schema":{"type":"array","items":{"type":"integer"},"example":[1,2,3]}}}},"responses":{"200":{"description":"Dashboard IDs updated","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"type":"integer"}}}}}}},"400":{"description":"Bad Request - validation error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/dashboard-ids/{dashboard_id}":{"delete":{"tags":["user-dashboard-ids"],"summary":"Remove and delete user's dashboard","description":"Removes a dashboard from user's list and permanently deletes it from the database.\nOnly dashboards of type \"user\" can be deleted via this endpoint.\nThe dashboard must belong to the specified user.\n","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"integer"}},{"in":"path","name":"dashboard_id","description":"Dashboard ID to remove and delete","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"Dashboard removed and deleted successfully"},"400":{"description":"Bad Request - dashboard does not belong to user or is not of type \"user\"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - insufficient permissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Dashboard not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/settings":{"put":{"tags":["users"],"summary":"Creates or replaces the user settings","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Settings"}}}},"responses":{"200":{"description":"User settings has been created or replaced","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/Settings"}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"delete":{"tags":["users"],"summary":"Deletes the user settings","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"responses":{"204":{"description":"User settings has been deleted"},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/notifications":{"patch":{"tags":["users"],"summary":"replaces the user notifications settings","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotificationSettings"}}}},"responses":{"200":{"description":"User dashboard has been created or replaced","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotificationSettings"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/reset-password":{"post":{"tags":["users"],"summary":"Sets a new user password","responses":{"204":{"description":"The user password has been changed"},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/last-time":{"patch":{"tags":["users"],"summary":"Mark all notification as read","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"responses":{"204":{"description":"User last-time has been updated"},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/users/{id}/notification-count":{"get":{"tags":["users"],"summary":"returns the number of unread notifications","parameters":[{"in":"path","name":"id","description":"User ID","required":true,"schema":{"type":"number"}}],"responses":{"200":{"description":"User last-time has been updated","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"count":{"type":"number","example":1}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"InternalServerError","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/translations/{language}":{"get":{"tags":["translations"],"summary":"Get translations.It is possible to get list by adding following body to request {\"id\":[234,532,5324]}","parameters":[{"in":"path","name":"language","schema":{"type":"string"},"required":true,"description":"lang id","example":"pl"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"path":{"type":"string"},"translation":{"type":"string"}}}}}}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"post":{"tags":["translations"],"summary":"Get translations.It is possible to get list by adding following body to request {\"id\":[234,532,5324]}","parameters":[{"in":"path","name":"language","schema":{"type":"string"},"required":true,"description":"lang id","example":"pl"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"path":{"type":"string"},"translation":{"type":"string"}}}}}}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/regulations/hashes":{"get":{"tags":["regulations"],"summary":"Get current regulation hashes (versions).","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"activity_data_consent":{"type":"string","readOnly":true,"example":"c116d19fa7c72e74830726b789e381088647c7a96a4201591224d43face7feff"},"privacy_policy":{"type":"string","readOnly":true,"example":"699d8076f7f3461ce254eca15d8a07be797c68223c1318bf6bdd32a66cb2aba0"},"terms_of_service":{"type":"string","readOnly":true,"example":"c095902b5daf04363bec543309f8c6d897713d8facf695a59f891913bd7db6c6"}}}}}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/regulations/body/{language}/{name}":{"get":{"tags":["regulations"],"summary":"Returns desired regulation body translated to selected lang.","parameters":[{"in":"path","name":"language","schema":{"type":"string","enum":["pl","en","cs","sk","hu","nl","de"]},"required":true,"description":"Language version of regulation body (content)"},{"in":"path","name":"name","schema":{"type":"string","enum":["activity_data_consent","privacy_policy","terms_of_service"]},"required":true,"description":"Name of regulation"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"string","readOnly":true,"example":"Markdown formatted regulation body goes here."}}}}}},"400":{"description":"Invalid name or language provided","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Regulation not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/feature-flags":{"get":{"tags":["feature-flags"],"summary":"Get feature flags JSON.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/FeatureFlags"}}}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/api-token":{"get":{"tags":["token-api"],"summary":"Get token-api list.","description":"Returns a list of all API tokens for the authenticated user. Supports both JWT (traditional) and short (24-character hex) token types.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"array","title":"ApiTokenCollection","items":{"type":"object","title":"ApiToken","properties":{"id":{"type":"integer","example":1},"name":{"type":"string","example":"My API Token"},"token":{"type":"string","description":"The actual token string. For JWT tokens, this is a long encoded string. For short tokens, this is a 24-character hex string.","example":"2e9dd4eb18a2d5f54c5143f1"},"token_type":{"type":"string","description":"Type of the token: \\\"jwt\\\" or \\\"short\\\"","enum":["jwt","short"],"example":"short"},"user_id":{"type":"integer","example":1},"created_at":{"type":"string","format":"date-time","example":"2022-07-07T07:58:41Z"},"expires_at":{"type":"string","format":"date-time","nullable":true,"description":"Expiration date for the token. Null means the token does not expire (default for short tokens).","example":null}}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"post":{"tags":["token-api"],"summary":"Add token-api.","requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["name"],"properties":{"name":{"type":"string","description":"Name of the token for identification","example":"My API Token"},"token_type":{"type":"string","description":"Type of token to create. Valid values: \\\"jwt\\\" or \\\"short\\\". Defaults to \\\"jwt\\\" if not specified.","enum":["jwt","short"],"default":"jwt","example":"short"}}},"examples":{"JWT Token":{"summary":"Create a JWT token","value":{"name":"Legacy JWT Token","token_type":"jwt"}},"Short Token":{"summary":"Create a short token","value":{"name":"Short API Token","token_type":"short"}}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","title":"ApiToken","properties":{"id":{"type":"integer","example":1},"name":{"type":"string","example":"My API Token"},"token":{"type":"string","description":"The actual token string. For JWT tokens, this is a long encoded string. For short tokens, this is a 24-character hex string.","example":"2e9dd4eb18a2d5f54c5143f1"},"token_type":{"type":"string","description":"Type of the token: \\\"jwt\\\" or \\\"short\\\"","example":"short"},"user_id":{"type":"integer","example":1},"created_at":{"type":"string","format":"date-time","example":"2022-07-07T07:58:41Z"},"expires_at":{"type":"string","format":"date-time","nullable":true,"description":"Expiration date. Null for non-expiring tokens.","example":null}}}}}}}},"400":{"description":"Bad Request - Invalid token_type or missing required fields","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/api-token/{id}":{"delete":{"tags":["token-api"],"summary":"delete token-api .","parameters":[{"in":"path","name":"id","description":"token ID","required":true,"schema":{"type":"number"}}],"responses":{"204":{"description":"Success."},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/firms":{"get":{"tags":["firm"],"summary":"Get extra firm list.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"firm":{"items":{"type":"string"}}},"example":{"firm":["defro","kolton"]}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"patch":{"tags":["firm"],"summary":"Edit extra firm .","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"firm":{"items":{"type":"string"}}}},"example":{"firm":["defro","kolton"]}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"firm":{"items":{"type":"string"}}},"example":{"firm":["defro","kolton"]}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/available-firms":{"get":{"tags":["firm"],"summary":"Get available firm list.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"firm":{"type":"array","items":{"type":"string"}}},"example":{"firm":["defro","kolton","tech"]}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/default-dashboards":{"get":{"tags":["default-dashboards"],"summary":"Get default dashboard IDs.","description":"Returns a list of dashboard IDs that are assigned to new users by default.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"ids":{"type":"array","items":{"type":"integer"},"example":[1,2,3]},"dashboards":{"type":"array","items":{"$ref":"#/components/schemas/Dashboard"}}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - only SUPER_ADMIN and ADMIN can access","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"put":{"tags":["default-dashboards"],"summary":"Set default dashboard IDs.","description":"Sets the list of dashboard IDs that are assigned to new users by default. Only dashboards of type \"default\" can be used.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","required":["ids"],"properties":{"ids":{"type":"array","items":{"type":"integer"},"example":[1,2,3]}}}}}},"responses":{"204":{"description":"Success - default dashboards updated."},"400":{"description":"Bad Request - invalid dashboard IDs or dashboards are not of type \"default\"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - only SUPER_ADMIN and ADMIN can modify","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/settings/default-dashboards/copy-from-user":{"post":{"tags":["default-dashboards"],"summary":"Copy user's dashboards as default dashboards.","description":"Creates copies of specified user's dashboards as new default dashboards.\n**Important:** Existing default dashboards are deleted before creating new ones to avoid orphaned dashboards.\n","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","required":["user_id"],"properties":{"user_id":{"type":"integer","description":"ID of the user whose dashboards will be copied","example":1}}}}}},"responses":{"200":{"description":"Success - dashboards copied as defaults.","content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"ids":{"type":"array","items":{"type":"integer"},"description":"IDs of newly created default dashboards","example":[10,11,12]},"dashboards":{"type":"array","items":{"$ref":"#/components/schemas/Dashboard"}}}}}}}}},"400":{"description":"Bad Request - user has no dashboards to copy","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"403":{"description":"Forbidden - only SUPER_ADMIN and ADMIN can modify","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found - user not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/connection-status":{"get":{"tags":["connection-status"],"summary":"Get cloud and internet connection status.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/ConnectionStatus"}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"Unknown server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/devices":{"get":{"tags":["devices"],"summary":"Get collection of all devices.","description":"Get collection of all devices.","parameters":[{"in":"query","name":"modified_since","schema":{"type":"integer"},"description":"Test"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices"],"summary":"Edit all existing devices.","description":"Edit all existing devices.","requestBody":{"description":"Generic device model.","required":true,"content":{"application/json":{"schema":{"type":"object","required":["color"],"properties":{"color":{"description":"HTML/Hex RGB representation of device widget color.","type":"string","pattern":"/^#[0-9a-f]{6}$/i"}}},"examples":{"ColorUpdate":{"description":"Update color for all device widgets.","value":{"color":"#ffcc00"}}}}}},"responses":{"204":{"$ref":"#/components/responses/NoContent"},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}},"delete":{"tags":["devices"],"summary":"Delete all devices in system.","description":"Delete all devices in system. **NOTE:** Some devices may remain if they cannot be deleted.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/tags":{"get":{"tags":["devices"],"summary":"Get list of all tags added to all devices.","description":"Get list of all tags added to all devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/TagCollection"}}},"example":{"data":["light","outlet","sensor"]}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-registration":{"get":{"tags":["devices"],"summary":"Get current state of device registration.","description":"Get current state of device registration.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.Registration"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-registration/enable":{"post":{"requestBody":{"description":"Request body is needed only when Lora gateway or Lora device is already registered","required":false,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Device.RegistrationBody"},"examples":{"RegistrationBody":{"$ref":"#/components/examples/Device.RegistrationBody"}}}}},"tags":["devices"],"summary":"Enable registration process.","description":"Enable registration process.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"409":{"$ref":"#/components/responses/RegistrationAlreadyInProgress"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-registration/disable":{"post":{"tags":["devices"],"summary":"Disable registration process.","description":"Disable registration process.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-identification/enable":{"post":{"tags":["devices"],"summary":"Enable devices identification process.","description":"Enable devices identification process.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"409":{"$ref":"#/components/responses/IdentificationAlreadyInProgress"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-identification/disable":{"post":{"tags":["devices"],"summary":"Disable devices identification process.","description":"Disable devices identification process.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/wtp":{"get":{"tags":["devices/wtp"],"summary":"Get collection of devices.","description":"Get collection of devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.WTP.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/wtp/{id}":{"get":{"tags":["devices/wtp"],"summary":"Get a device by ID","description":"Get a device by ID","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to get"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.WTP.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices/wtp"],"summary":"Edit existing device.","description":"Edit existing device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to edit"}],"requestBody":{"description":"WTP device model.<br> **NOTE:** Read-only parameters eg. `id`, `type`, `class`, `messages` etc should not be sent. See schema for more info.<br> **NOTE:** Partial update is possible by sending single member of object, then rest of values remain unmodified. (See PartialUpdateExampe)","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.WTP.OneOf"}]},"examples":{"Relay":{"$ref":"#/components/examples/Device.WTP.Relay"},"TemperatureSensor":{"$ref":"#/components/examples/Device.WTP.TemperatureSensor"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.WTP.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}},"delete":{"tags":["devices/wtp"],"summary":"Delete device by ID.","description":"Delete device by ID. It is possible to delete all related devices i.e. with the same address by adding following body to request `{\"delete_related\":true}`","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to delete"}],"responses":{"200":{"$ref":"#/components/responses/DevicesSuccessfullyDeleted"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/wtp/{id}/command/{command}":{"post":{"tags":["devices/wtp"],"summary":"Sends command to Device","description":"Sends command to Device","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device for which command should be called"},{"in":"path","name":"command","schema":{"type":"string"},"required":true,"description":"Device specific command name. See commands schema descriptions for more info."}],"requestBody":{"description":"Command represented as name -> parameters object. See commands schema descriptions for more info.","content":{"application/json":{"schema":{"allOf":[{"type":"object"},{"$ref":"#/components/schemas/DeviceCommand.WTP.OneOf"}]}}}},"responses":{"200":{"description":"Success, returns updated object.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.WTP.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/tech":{"get":{"tags":["devices/tech"],"summary":"Get collection of devices.","description":"Get collection of devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.TECH.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/tech/{id}":{"get":{"tags":["devices/tech"],"summary":"Get a device by ID","description":"Get a device by ID","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to get"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.TECH.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices/tech"],"summary":"Edit existing device.","description":"Edit existing device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to edit"}],"requestBody":{"description":"TECH device model.<br> **NOTE:** Read-only parameters eg. `id`, `type`, `class`, `messages` etc should not be sent. See schema for more info.<br> **NOTE:** Partial update is possible by sending single member of object, then rest of values remain unmodified. (See PartialUpdateExampe)","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.TECH.OneOf"}]},"examples":{"Relay":{"$ref":"#/components/examples/Device.TECH.Relay"},"TemperatureSensor":{"$ref":"#/components/examples/Device.TECH.TemperatureSensor"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.TECH.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/tech/{id}/command/{command}":{"post":{"tags":["devices/tech"],"summary":"Sends command to Device","description":"Sends command to Device","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device for which command should be called"},{"in":"path","name":"command","schema":{"type":"string"},"required":true,"description":"Device specific command name. See commands schema descriptions for more info."}],"requestBody":{"description":"Command represented as name -> parameters object. See commands schema descriptions for more info.","content":{"application/json":{"schema":{"allOf":[{"type":"object"},{"$ref":"#/components/schemas/DeviceCommand.TECH.OneOf"}]}}}},"responses":{"200":{"description":"Success, returns updated object.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.TECH.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/modbus":{"get":{"tags":["devices/modbus"],"summary":"Get collection of Modbus devices.","description":"Get collection of Modbus devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.Modbus.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/modbus/{id}":{"get":{"tags":["devices/modbus"],"summary":"Get a device by ID","description":"Get a device by ID","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to get"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.Modbus.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices/modbus"],"summary":"Edit existing Modbus device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to edit."}],"requestBody":{"description":"Modbus device model.<br> **NOTE:** Read-only parameters eg. `id`, `type`, `class`, `messages` etc should not be sent. See schema for more info.<br> **NOTE:** Partial update is possible by sending single member of object, then rest of values remain unmodified. (See PartialUpdateExampe)","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.Modbus.OneOf"}]},"examples":{"EcoAirHeatPump":{"$ref":"#/components/examples/Device.Modbus.EcoAirHeatPump"},"AlphaInnotecMainDhw":{"$ref":"#/components/examples/Device.Modbus.AlphaInnotecMainDhw"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.Modbus.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}},"delete":{"tags":["devices/modbus"],"summary":"Delete device by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to delete"}],"responses":{"200":{"$ref":"#/components/responses/DevicesSuccessfullyDeleted"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/modbus/{id}/command/{command}":{"post":{"tags":["devices/modbus"],"summary":"Sends command to Modbus Device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device for which command should be called."},{"in":"path","name":"command","schema":{"type":"string"},"required":true,"description":"Device specific command name. See commands schema descriptions for more info."}],"requestBody":{"description":"Command represented as name -> parameters object. See commands schema descriptions for more info.","content":{"application/json":{"schema":{"allOf":[{"type":"object"},{"$ref":"#/components/schemas/DeviceCommand.Modbus.OneOf"}]}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.Modbus.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-network/modbus":{"get":{"tags":["device-network"],"summary":"Get collection of Modbus devices diagnostic information.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.ModbusParentDeviceDiagnosticInfo.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-network/modbus/{id}":{"get":{"tags":["device-network"],"summary":"Get Modbus device diagnostic info by parent device ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the modbus parent device to get."}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/ModbusParentDeviceDiagnosticInfo"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-network/sbus":{"get":{"tags":["device-network"],"summary":"Get collection of SBus devices diagnostic information.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"description":"SBus devices diagnostic information.","type":"object"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/device-network/wtp":{"get":{"tags":["device-network"],"summary":"Get collection of WTP devices diagnostic information.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"description":"WTP devices diagnostic information.","type":"object"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual":{"get":{"tags":["devices/virtual"],"summary":"Get collection of devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"post":{"tags":["devices/virtual"],"summary":"Add new virtual device.","requestBody":{"description":"VIRTUAL device model.<br> **NOTE:** Parameter `id` is ignored. (Read-only)<br> **NOTE:** Parameter `type` is required.<br> **NOTE:** Since keys are optional (excluding these mentioned in notes), missing values will be set to default.<br> **NOTE:** Adding **Gate** requires `variant` to be set to one of following values: `sliding_gate`, `swing_gate` or `garage_gate`!<br> **NOTE:** When adding **CustomDevice** you can choose type of custom device by setting `variant` to one of following values: `generic`, `temperature_sensor`, `heat_pump`, `inverter`, `energy_meter`, `battery`, `common_dhw_main`.","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]},"examples":{"Thermostat":{"$ref":"#/components/examples/Device.VIRTUAL.Thermostat"},"CustomDevice":{"$ref":"#/components/examples/Device.VIRTUAL.CustomDevice"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"ObjectAllocationError":{"$ref":"#/components/examples/Response.ObjectAllocationError"},"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}},"503":{"$ref":"#/components/responses/ObjectContainerBusyError"}}}},"/devices/virtual/{id}":{"get":{"tags":["devices/virtual"],"summary":"Get a device by ID","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to get"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices/virtual"],"summary":"Edit existing device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to edit"}],"requestBody":{"description":"VIRTUAL device model.<br> **NOTE:** Read-only parameters eg. `id`, `type`, `class`, `messages` etc should not be sent. See schema for more info.<br> **NOTE:** Partial update is possible by sending single member of object, then rest of values remain unmodified. (See PartialUpdateExampe)","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]},"examples":{"Thermostat":{"$ref":"#/components/examples/Device.VIRTUAL.Thermostat"},"CustomDevice":{"$ref":"#/components/examples/Device.VIRTUAL.CustomDevice"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}},"delete":{"tags":["devices/virtual"],"summary":"Delete device by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to delete"}],"responses":{"200":{"$ref":"#/components/responses/DevicesSuccessfullyDeleted"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/virtual/{id}/logs":{"get":{"tags":["devices/virtual"],"summary":"Get custom device logs by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/LuaLog.Collection"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/lua":{"get":{"tags":["devices/virtual"],"summary":"Get custom device lua code by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"type":"string","example":"wtp[5]:setValue(\"state\", false)"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/lua-extensions":{"get":{"tags":["devices/virtual"],"summary":"Get custom device lua code with extensions by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"type":"object","required":["lua","lua_extensions"],"properties":{"lua":{"type":"string","example":"local ext = require(\"ext\")\\n print(ext(10))"},"lua_extensions":{"type":"array","items":{"anyOf":[{"$ref":"#/components/schemas/LuaExtension"}]}}}}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/command/{command}":{"post":{"tags":["devices/virtual"],"summary":"Sends command to Device","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device for which command should be called"},{"in":"path","name":"command","schema":{"type":"string"},"required":true,"description":"Device specific command name. See commands schema descriptions for more info."}],"requestBody":{"description":"Command represented as name -> parameters object. See commands schema descriptions for more info.","content":{"application/json":{"schema":{"allOf":[{"type":"object"},{"$ref":"#/components/schemas/DeviceCommand.VIRTUAL.OneOf"}]}}}},"responses":{"200":{"description":"Success, returns updated object.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/element/{name}/command/{command}":{"post":{"tags":["devices/virtual"],"summary":"Sends command to Custom Device`s element","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device"},{"in":"path","name":"name","schema":{"type":"string"},"required":true,"description":"Name of element."},{"in":"path","name":"command","schema":{"type":"string"},"required":true,"description":"Element specific command name. See commands schema descriptions for more info."}],"requestBody":{"description":"Command represented as name -> parameters object. See commands schema descriptions for more info.","content":{"application/json":{"schema":{"allOf":[{"type":"object"},{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.ElementCommand.OneOf"}]}}}},"responses":{"200":{"description":"Success, returns updated object.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.ElementOneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/config-started":{"post":{"tags":["devices/virtual"],"summary":"Notify CustomDevice that configuration started.","description":"Executes `onConfigStarted` in custom device. Should be called when configuration view is opened by user.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"204":{"$ref":"#/components/responses/NoContent"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/virtual/{id}/config-finished":{"post":{"tags":["devices/virtual"],"summary":"Notify CustomDevice that configuration finished.","description":"Executes `onConfigFinished` in custom device. Should be called when configuration view is closed by user.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"204":{"$ref":"#/components/responses/NoContent"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/virtual/{id}/unban":{"post":{"tags":["devices/virtual"],"summary":"Unban custom device by ID.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"204":{"$ref":"#/components/responses/NoContent"},"304":{"$ref":"#/components/responses/NotModified"},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/virtual/{id}/check-update":{"post":{"tags":["devices/virtual"],"summary":"Check marketplace update of custom device.","description":"Check marketplace update of custom device.<br>**NOTE:** May only be used on custom devices imported from marketplace.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"responses":{"204":{"$ref":"#/components/responses/NoContent"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/virtual/{id}/update":{"post":{"tags":["devices/virtual"],"summary":"Update custom device from marketplace or payload.","description":"Update custom device from marketplace or payload.<br>**NOTE:** When no payload provided it may only be used on custom devices imported from marketplace and when its `software_status` is `update_available`.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"requestBody":{"description":"Custom device to update.","required":false,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.Export"}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice"}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}},"503":{"$ref":"#/components/responses/NoDataAvailable"}}}},"/devices/virtual/{id}/export":{"post":{"tags":["devices/virtual"],"summary":"Export custom device.","description":"Export custom device.<br>**NOTE:**Blocked custom device cannot be exported.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the custom device"}],"requestBody":{"description":"Parameters of exporting","required":true,"content":{"application/json":{"schema":{"type":"object","required":["blocked"],"properties":{"blocked":{"description":"Indicates whether custom device should be exported as blocked. When someone import blocked custom device they cannot modify it.","type":"boolean","example":false}}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.Export"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/import/virtual":{"post":{"tags":["devices/virtual"],"summary":"Import custom device.","requestBody":{"description":"Custom device to import.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.Export"}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"ObjectAllocationError":{"$ref":"#/components/examples/Response.ObjectAllocationError"},"ContainerOperationError":{"$ref":"#/components/examples/Response.ContainerOperationError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/devices/virtual/{id}/validate-pin-code":{"post":{"tags":["devices/virtual"],"summary":"Validate pin code of custom device.","description":"Validate pin code to modify or delete device for device with given `id`. Compare with device pin code when `blockade_pin_code_enabled` set to true or return success if blockade not enabled.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the virtual device"}],"requestBody":{"description":"Pin code to validate.","required":true,"content":{"application/json":{"schema":{"type":"object","required":["blockade_pin_code"],"properties":{"blockade_pin_code":{"description":"Pin code to validate.","type":"string","example":"1234"}}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice.Export"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"405":{"$ref":"#/components/responses/MethodNotAllowed"},"408":{"$ref":"#/components/responses/RequestTimeout"},"422":{"$ref":"#/components/responses/ValidationFailed"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/marketplace/check-updates":{"post":{"tags":["marketplace"],"summary":"Check updates of every object imported from marketplace.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}}}}},"/marketplace/custom-device/{uuid}":{"post":{"tags":["marketplace"],"summary":"Import custom device from marketplace","parameters":[{"in":"path","name":"uuid","schema":{"type":"string"},"required":true,"description":"UUID of custom device in marketplace."}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.VIRTUAL.CustomDevice"}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"description":"Server side error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"DatabaseError":{"$ref":"#/components/examples/Response.DatabaseError"},"ObjectAllocationError":{"$ref":"#/components/examples/Response.ObjectAllocationError"},"ContainerOperationError":{"$ref":"#/components/examples/Response.ContainerOperationError"},"UnknownError":{"$ref":"#/components/examples/Response.UnknownError"}}}}},"504":{"description":"Timeout Error.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"AsyncResponseTimeout":{"$ref":"#/components/examples/Response.AsyncResponseTimeout"}}}}}}}},"/devices/sbus":{"get":{"tags":["devices/sbus"],"summary":"Get collection of devices.","responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"$ref":"#/components/schemas/Device.SBus.Collection"}}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}}},"/devices/sbus/{id}":{"get":{"tags":["devices/sbus"],"summary":"Get a device by ID","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to get"}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.SBus.OneOf"}]}}}}}},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"},"404":{"$ref":"#/components/responses/ObjectNotFound"},"408":{"$ref":"#/components/responses/RequestTimeout"},"500":{"$ref":"#/components/responses/UnknownError"}}},"patch":{"tags":["devices/sbus"],"summary":"Edit existing device.","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"Numeric ID of the device to edit"}],"requestBody":{"description":"SBUS device model.<br> **NOTE:** Read-only parameters eg. `id`, `type`, `class`, `messages` etc should not be sent. See schema for more info.<br> **NOTE:** Partial update is possible by sending single member of object, then rest of values remain unmodified. (See PartialUpdateExampe)","required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/Device.SBus.OneOf"}]},"examples":{"Relay":{"$ref":"#/components/examples/Device.SBus.Relay"},"TemperatureSensor":{"$ref":"#/components/examples/Device.SBus.TemperatureSensor"},"PartialUpdateExample":{"$ref":"#/components/examples/PartialUpdateExample"}}}}},"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"type":"object","required":["data"],"properties":{"data":{"allOf":[{"$ref":"#/components/schemas/Device.SBus.OneOf"}]}}}}}},"304":{"$ref":"#/components/responses/NotModified"},"400":{"description":"Bad request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Response.Error"},"examples":{"InvalidObjectIdSupplied":{"$ref":"#/components/examples/Response.InvalidObjectIdSupplied"},"EmptyDataError":{"$ref":"#/components/examples/Response.EmptyDataError"},"RequestParseError":{"$ref":"#/components/examples/Response.RequestParseError"},"GoRequestParseError":{"$ref":"#/components/examples/Response.GoRequestParseError"}}}}},"401":{"$ref":"#/components/responses/UnauthorizedError"
[...]
